class Score < ActiveRecord::Base
  has_many :score_user_categories, dependent: :destroy
  has_many :user_categories, through: :score_user_categories

  validates_presence_of :name, :code, :weight
  validates_uniqueness_of :code

  def max_value
    score_user_categories.maximum(:value)
  end

  def category_value(category)
    score = score_user_categories.where(score: self, user_category: category).first
    (score.nil?) ? nil : score.value
  end
end
